!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
program scanmdlog
  use util
  use inspectstr
  implicit none

  real(kind=8),parameter:: pi = 3.14159265358979323846d0

  real(kind=8):: aa0(3,3),bb0(3,3),aa(3,3),bb(3,3),va0
  real(kind=8):: aamk(3,3),aaprn(3,3)
  real(kind=8):: deltm,time
  integer:: nsi,nkd
  real(kind=8),dimension(:,:),allocatable:: asi,casi,casir,cforce,cavl, &
       casiprn,casimk,casimkr,cforceai,casib
  integer,allocatable:: kd(:)
  real(kind=8):: etotal,enthalpy,eknuc,sysvol,total_stress,order
  real(kind=8):: setotal(6), setotalai(6)
  real(kind=8):: ordermk
  real(kind=8):: etotalai,enthalpyai,total_stress_ai
  real(kind=8):: etotalmk
  real(kind=8):: stern_cons
  real(kind=8):: totmom(3),ctomas(3)
  real(kind=8):: zeta,eta,sigma
  logical:: ifperfai
  real(kind=8):: ctmp(3)

  real(kind=8):: sysscl

  integer:: nstep,istep,nskip
  integer:: stepmk
  integer:: ngx,ngy,ngz,ngxyz
  real(kind=8),allocatable:: strpow(:,:),ag(:)
  integer,allocatable:: kg(:,:),idx(:),tkg(:,:)
  integer:: kgmax(3)
  character(len=3):: asym(130)
  integer:: nasym,ikd

  character(len=256):: buf
  character(len=256):: basename, ofname, ifname, argv(1)
  integer,parameter:: nfin = 10,nfout = 11,nfxyz = 12,nfasi = 13
  integer,parameter:: nftmcm = 14, nfgyrad = 15, nfsqdspl = 16, nfbegstr = 17
  real(kind=8),parameter:: one_au = 0.529177249
  integer:: ios,ierr
  integer:: igx,igy,igz,ig,it,isg
  real(kind=8):: g(3), gsq
  real(kind=8):: h(3), gmax
  integer:: nkg

  logical:: rflag,wrasiflag,wrtmcmflag,gyradflag,sqdsplflag,sqdspliniflag
  integer:: period,bstep,estep
  integer:: xti(3)

  integer:: nspecg,tkd
  integer:: spc_pwr
  integer,allocatable:: speckg(:,:)
  real(kind=8):: specstrpow
  real(kind=8):: specstrpowmk

  integer:: nd,neng,nord,id,ie,io
  real(kind=8):: dbase,deld,ebase,dele,obase,delo
  real(kind=8):: sd,seng,sord,fac
  integer,allocatable:: dhist(:,:,:)
  real(kind=8),allocatable:: d(:,:,:)
  integer,allocatable:: nsikd(:)
  real(kind=8),allocatable:: gyrad(:),sqdspl(:)
  

  call getarg(1, argv(1))
  if (len_trim(argv(1)) .eq. 0) then
     write(6,*) 'invalid fname'
     stop
  end if
  basename = argv(1)
  ifname = trim(basename) // '.scan'
  open(nfin, file=ifname, status='old', action='read', form='formatted')
  read(nfin,*) nasym
  do ikd=1,nasym
     read(nfin,*) asym(ikd)
  end do
  read(nfin,*) rflag, period
  read(nfin,*) xti(1),xti(2),xti(3)
  read(nfin,*) ngx,ngy,ngz

  read(nfin,'(a256)',IOSTAT=ios) buf

  if (trim(buf) .eq. 'speckg') then
     read(nfin,'(a256)') buf
     read(buf,*,IOSTAT=ios) nspecg,tkd,spc_pwr
     if (ios.lt.0) then
        spc_pwr = 1
        read(buf,*) nspecg,tkd
     end if
     allocate(speckg(3,nspecg))
     do isg=1,nspecg
        read(nfin,*) speckg(1,isg),speckg(2,isg),speckg(3,isg)
     end do
     read(nfin,'(a256)',IOSTAT=ios) buf
  else
     nspecg = 0
  end if

  if (trim(buf) .eq. 'disthist') then
     read(nfin,*) nd,dbase,deld
     read(nfin,*) neng,ebase,dele
     read(nfin,*) nord,obase,delo
     read(nfin,'(a256)',IOSTAT=ios) buf
  else
     nd = 0
     neng = 0
     nord = 0
  end if

  wrasiflag = .false.
  if (trim(buf) .eq. 'writeasi') then
     wrasiflag = .true.
     read(nfin,'(a256)',IOSTAT=ios) buf
  end if

  if (trim(buf) .eq. 'skip') then
     read(nfin,*) nskip
     read(nfin,'(a256)',IOSTAT=ios) buf
     bstep = nskip + 1
     estep = huge(1)
  else if (trim(buf) .eq. 'range') then
     read(nfin,*) bstep, estep
     read(nfin,'(a256)',IOSTAT=ios) buf
  else
     bstep = 1
     estep = huge(1)
  end if

  wrtmcmflag = .false.
  if (trim(buf) .eq. 'tmoncmas') then
     wrtmcmflag = .true.
     read(nfin,'(a256)',IOSTAT=ios) buf
  end if

  gyradflag = .false.
  if (trim(buf) .eq. 'gyrad') then
     gyradflag = .true.
     read(nfin,'(a256)',IOSTAT=ios) buf
  end if

  sqdsplflag = .false.
  sqdspliniflag = .true.
  if (trim(buf) .eq. 'sqdspl') then
     sqdsplflag = .true.
     sqdspliniflag = .false.
  else if (trim(buf) .eq. 'sqdspl ini') then
     sqdsplflag = .true.
  end if

  close(nfin)

  ifname = trim(basename) // '.mdlog'
  open(nfin, file=ifname, status='old', action='read', form='unformatted')

  read(nfin) deltm
  read(nfin) aa0(1,1),aa0(2,1),aa0(3,1)
  read(nfin) aa0(1,2),aa0(2,2),aa0(3,2)
  read(nfin) aa0(1,3),aa0(2,3),aa0(3,3)
  read(nfin) nsi,nkd

  ofname = trim(basename) // '.cell'
  open(nfout, file=ofname, status='unknown', action='write', form='unformatted')
  write(nfout) nsi,aa0
  close(nfout)

  va0 = cellvol(aa0)
  call recp_uvec(aa0,bb0)

  call LatticeInterval(bb0,h)
  h(1) = h(1)*ngx
  h(2) = h(2)*ngy
  h(3) = h(3)*ngz
  gmax = minval(h)

  allocate(asi(3,nsi),casi(3,nsi),casir(3,nsi),cforce(3,nsi),cavl(3,nsi), &
       casiprn(3,nsi),casimk(3,nsi),casimkr(3,nsi),kd(nsi),cforceai(3,nsi), &
       casib(3,nsi))
  allocate(d(4,nsi,nsi),dhist(nd,neng,nord))
  dhist = 0

  ngxyz = (2*ngx+1)*(2*ngy+1)*(2*ngz+1)
  allocate(strpow(nkd,ngxyz),ag(ngxyz),kg(3,ngxyz),idx(ngxyz),tkg(3,ngxyz))

  allocate(nsikd(nkd),gyrad(nkd),sqdspl(nkd))

  ofname = trim(basename) // '.ev'
  open(nfout, file=ofname, status='unknown', action='write', form='formatted')

  ofname = trim(basename) // '.xyz'
  open(nfxyz, file=ofname, status='unknown', action='write', form='formatted')

  if (wrasiflag) then
     ofname = trim(basename) // '.asi'
     open(nfasi, file=ofname, status='unknown', action='write', &
          form='unformatted')
  end if

  if (wrtmcmflag) then
     ofname = trim(basename) // '.tmcm'
     open(nftmcm, file=ofname, status='unknown', action='write', &
          form='formatted')
  end if

  if (gyradflag) then
     ofname = trim(basename) // '.gyrad'
     open(nfgyrad, file=ofname, status='unknown', action='write', &
          form='formatted')
  end if

  if (sqdsplflag) then
     ofname = trim(basename) // '.sqdspl'
     open(nfsqdspl, file=ofname, status='unknown', action='write', &
          form='formatted')
  end if
  if (.not. sqdspliniflag) then
     ifname = trim(basename) // '.begstr'
     open(nfbegstr, file=ifname, status='unknown', action='read', &
          form='unformatted')
     read(nfbegstr) casib
     close(nfbegstr)
  end if

  ig = 0
  do igz=-ngz,ngz
     do igy=-ngy,ngy
        do igx=-ngx,ngx
           g(1) = bb0(1,1)*igx + bb0(1,2)*igy + bb0(1,3)*igz
           g(2) = bb0(2,1)*igx + bb0(2,2)*igy + bb0(2,3)*igz
           g(3) = bb0(3,1)*igx + bb0(3,2)*igy + bb0(3,3)*igz
           gsq = g(1)*g(1) + g(2)*g(2) + g(3)*g(3)
           if (sqrt(gsq).lt.gmax) then
              ig = ig + 1
              ag(ig) = gsq
              tkg(1,ig) = igx
              tkg(2,ig) = igy
              tkg(3,ig) = igz
           end if
        end do
     end do
  end do
  nkg = ig

  call hsort(nkg,ag,idx)
  kgmax = 0
  do ig=1,nkg
     kg(1,ig) = tkg(1,idx(ig))
     kg(2,ig) = tkg(2,idx(ig))
     kg(3,ig) = tkg(3,idx(ig))
     kgmax(1) = max(kgmax(1),abs(kg(1,ig)))
     kgmax(2) = max(kgmax(2),abs(kg(2,ig)))
     kgmax(3) = max(kgmax(3),abs(kg(3,ig)))
  end do

  strpow = 0.0d0
  specstrpow = 0.0d0

  etotalmk = huge(1.0d0)
  specstrpowmk = 0.0d0
  ordermk = -huge(1.0d0)

  istep = 0
  nstep = 0
  do while (.true.)
     read(nfin,IOSTAT=ios) ifperfai,time
     if (ios.lt.0) exit
     istep = istep + 1
     if (ifperfai) then
        read(nfin) etotal, etotalai, order
        read(nfin) enthalpy, enthalpyai
     else
        read(nfin) etotal, order
        read(nfin) enthalpy
     end if
     read(nfin) eknuc
     read(nfin) sysvol
     read(nfin) stern_cons
     read(nfin) totmom, ctomas
     read(nfin) zeta,eta,sigma
     read(nfin) kd,casi
     if (ifperfai) then
        read(nfin) total_stress, total_stress_ai, setotal, setotalai
        read(nfin) cforce, cforceai
     else
        read(nfin) total_stress, setotal
        read(nfin) cforce
     end if
     read(nfin) cavl

     if ( (istep.lt.bstep) .or. (istep.gt.estep) ) then
        cycle
     else
        nstep = nstep + 1
     end if

     sysscl = (sysvol/va0)**(1.0d0/3.0d0)
     aa = aa0*sysscl
     bb = bb0/sysscl

     call cart2cellr(aa,nsi,casi,asi)
     call cell2cart(aa,nsi,asi,casir)

     nsikd = 0
     do it=1,nsi
        nsikd(kd(it)) = nsikd(kd(it)) + 1
     end do

     call calstrpow(nkg,ngxyz,kg,kgmax,nsi,kd,asi,nkd,strpow)

     if (nspecg.gt.0) then
        specstrpow = calspecspw(nspecg,speckg,nsi,kd,asi,tkd,spc_pwr)
     end if

     if (nd.gt.0) then
        call caldist(nsi,asi,aa,d)
        ie = (etotal - ebase)/dele + 1
        io = (specstrpow - obase)/delo + 1
        call histdist(nsi,d,dbase,deld,nd,dhist(:,ie,io))
     end if

     !if (etotal.lt.etotalmk) then
     !if (specstrpow.gt.specstrpowmk) then
     if (order.gt.ordermk) then
        etotalmk = etotal
        specstrpowmk = specstrpow
        ordermk = order
        casimk = casi
        casimkr = casir
        aamk = aa
        stepmk = istep
     end if

     if (nspecg.gt.0) then
        write(nfout,'(3(1x,e18.11),5(1x,e10.3),1x,e18.11,3(1x,e15.8))') &
             etotal, sysvol, enthalpy, eknuc, total_stress, &
             zeta, eta, sigma, stern_cons, time, specstrpow, order
     else
        write(nfout,'(3(1x,e18.11),5(1x,e10.3),1x,e18.11,2(1x,e15.8))') &
             etotal, sysvol, enthalpy, eknuc, total_stress, &
             zeta, eta, sigma, stern_cons, time, order
     end if

     if (wrasiflag) then
        write(nfasi) time,nsi,aa,etotal,sysvol,order,total_stress
        write(nfasi) asi,kd
     end if

     if (wrtmcmflag) then
        write(nftmcm,'(7(1x,e18.11))') time,totmom,ctomas
     end if

     if (gyradflag) then
        gyrad = 0.0d0
        do it=1,nsi
           gyrad(kd(it)) = gyrad(kd(it)) + casi(1,it)*casi(1,it) &
                + casi(2,it)*casi(2,it) + casi(3,it)*casi(3,it)
        end do
        do ikd=1,nkd
           if (nsikd(ikd).gt.0) then
              gyrad(ikd) = sqrt(gyrad(ikd)/nsikd(ikd))
           else
              gyrad(ikd) = -1.0d0
           end if
        end do
        write(nfgyrad,'(100(1x,e18.11))') &
             time, (gyrad(ikd),ikd=1,nkd)
     end if

     if (sqdsplflag) then
        if (.not. sqdspliniflag) then
           sqdspl = 0.0d0
           do it=1,nsi
              ctmp = casi(:,it) - casib(:,it)
              sqdspl(kd(it)) = sqdspl(kd(it)) + &
                   ctmp(1)*ctmp(1) + ctmp(2)*ctmp(2) + ctmp(3)*ctmp(3)
           end do
           do ikd=1,nkd
              if (nsikd(ikd).gt.0) then
                 sqdspl(ikd) = sqdspl(ikd)/nsikd(ikd)
              else
                 sqdspl(ikd) = -1.0d0
              end if
           end do
           write(nfsqdspl,'(100(1x,e18.11))') &
                time, (sqdspl(ikd),ikd=1,nkd)
        else if (istep .eq. bstep) then
           do it=1,nsi
              casib(:,it) = casi(:,it)
           end do
           ofname = trim(basename) // '.begstr'
           open(nfbegstr, file=ofname, status='unknown', action='write', &
                form='unformatted')
           write(nfbegstr) casib
           close(nfbegstr)
           sqdspliniflag = .false.
        end if
     end if

     if ( mod(istep - bstep,period) .eq. 0 ) then
        write(nfxyz,'(1x,i5)') nsi

        write(nfxyz,'(1x,i8,'' E = '',e18.11,'' O = '',e18.11,'' tm = '',e18.11)') &
             istep, etotal, order, time

        if (rflag) then
           casiprn = one_au*casir
        else
           casiprn = one_au*casi
        end if

        aaprn = one_au*aa
        write(nfxyz,'(1x,a,3(1x,e18.11),'' crystal_images'',3(1x,i3),'' crystal_vector 1'',3(1x,e18.11),'' crystal_vector 2'',3(1x,e18.11),'' crystal_vector 3'',3(1x,e18.11))') &
             asym(kd(1)),casiprn(1,1),casiprn(2,1),casiprn(3,1), &
             xti(1),xti(2),xti(3),aaprn
        do it=2,nsi
           write(nfxyz,'(1x,a,3(1x,e18.11))') asym(kd(it)), &
                casiprn(1,it),casiprn(2,it),casiprn(3,it)
        end do
     end if
  end do

  close(nfout)
  close(nfxyz)
  if (wrasiflag) close(nfasi)
  if (wrtmcmflag) close(nftmcm)
  if (gyradflag) close(nfgyrad)

  ofname = trim(basename) // '.strpow'
  open(nfout, file=ofname, status='unknown', action='write', form='formatted')
  
  strpow = strpow/nstep

  write(nfout,'(1x,a,3(1x,i5))') '# ngx,ngy,ngz =', ngx, ngy, ngz
  write(nfout,'(1x,a,e18.11)') '# gmax = ', gmax

  do ig=2,nkg
     igx = kg(1,ig)
     igy = kg(2,ig)
     igz = kg(3,ig)
     write(nfout,'(1x,e18.11,3(1x,i5),120(1x,e12.5))') &
          2.0d0*pi/sqrt(ag(ig)),igx,igy,igz,(strpow(ikd,ig),ikd=1,nkd)
  end do
  
  close(nfout)

  ofname = trim(basename) // '.xyzmk'
  open(nfxyz, file=ofname, status='unknown', action='write', form='formatted')

  write(nfxyz,'(1x,i5)') nsi

  write(nfxyz,'(1x,i8,'' E = '',e18.11,'' O = '',e18.11,'' S = '',e18.11)') &
       stepmk, etotalmk, ordermk, specstrpowmk

  if (rflag) then
     casiprn = one_au*casimkr
  else
     casiprn = one_au*casimk
  end if

  aaprn = one_au*aamk
  write(nfxyz,'(1x,a,3(1x,e18.11),'' crystal_images'',3(1x,i3),'' crystal_vector 1'',3(1x,e18.11),'' crystal_vector 2'',3(1x,e18.11),'' crystal_vector 3'',3(1x,e18.11))') &
       asym(kd(1)),casiprn(1,1),casiprn(2,1),casiprn(3,1), &
       xti(1),xti(2),xti(3),aaprn
  do it=2,nsi
     write(nfxyz,'(1x,a,3(1x,e18.11))') asym(kd(it)), &
          casiprn(1,it),casiprn(2,it),casiprn(3,it)
  end do
  close(nfxyz)

  if (nd.gt.0) then
     ofname = trim(basename) // '.dist'
     open(nfout, file=ofname, status='unknown', action='write', &
          form='formatted')

     fac = 2.0d0/(nstep*nsi)
     do io=1,nord
        do ie=1,neng
           do id=1,nd
              sd = dbase+deld*(id-1)
              seng = ebase+dele*(ie-1)
              sord = obase+delo*(io-1)
              write(nfout,'(4(1x,e12.5))') &
                   sd, seng, sord, dble(dhist(id,ie,io))*fac
           end do
           write(nfout,*)
        end do
        write(nfout,*)
     end do

     close(nfout)
  end if

  stop
end program scanmdlog
