#! /usr/bin/python
# Copyright (c) 2015 Yoshihide Yoshimoto

import yaml
import numpy as np
import sys
import subprocess
import shlex
import getopt

opts, args = getopt.getopt(sys.argv[1:],"p:")

strconvprog = "strconv"

for o, a in opts:
   if o == "-p":
      strconvprog = a

oneau = 0.5291772108
fac =27.2113845/0.5291772108

dispdotyaml = open('disp.yaml').read()
data = yaml.load(dispdotyaml)

asym2numdotyaml = open('asym2num.yaml').read()
asym2num = yaml.load(asym2numdotyaml)

basename = args[0]

f = open("FORCE_SETS",'w')

f.write("{0:d}\n".format(data['natom']))
f.write("{0:d}\n".format(len(data['displacements'])))

for j, adsp in enumerate(data['displacements']):
   tatm = adsp['atom']
   d_aa = np.mat(adsp['displacement']).T
   f.write("\n  {0:d}\n".format(tatm))
   f.write("  {0:19.11E} {1:19.11E} {2:19.11E}\n".format(d_aa.item(0),d_aa.item(1),d_aa.item(2)))

   bname = basename+"-{0:0>3d}".format(j+1)
   cmd = strconvprog + " cforce " + bname + ".str"
   proc = subprocess.Popen(shlex.split(cmd),stderr=subprocess.PIPE,
                        stdout=subprocess.PIPE)
   res = proc.communicate()
   for line in res[0].splitlines():
      items = line.split()
      x = fac*float(items[0])
      y = fac*float(items[1])
      z = fac*float(items[2])
      f.write("{0:19.11E} {1:19.11E} {2:19.11E}\n".format(x,y,z))

f.close()
