#! /usr/bin/python
# Copyright (c) 2015 Yoshihide Yoshimoto

import yaml
import numpy as np
import sys

oneau = 0.5291772108

dispdotyaml = open('disp.yaml').read()
data = yaml.load(dispdotyaml)

asym2numdotyaml = open('asym2num.yaml').read()
asym2num = yaml.load(asym2numdotyaml)

basename = sys.argv[1]
xtitmpl = open(basename+".tmpl").read()

s1 = xtitmpl.replace('{NUMBER_ATOM}', "{0:d}".format(data['natom']))

aa = np.mat(data['lattice']).T / oneau

s2 = s1.replace('{LATTICE_LIST}',
               ("{0:19.11E},{1:19.11E},{2:19.11E},"
               +"{3:19.11E},{4:19.11E},{5:19.11E},"
               +"{6:19.11E},{7:19.11E},{8:19.11E}").format(
                 aa.item((0,0)),aa.item((1,0)),aa.item((2,0)),
                 aa.item((0,1)),aa.item((1,1)),aa.item((2,1)),
                 aa.item((0,2)),aa.item((1,2)),aa.item((2,2))))

invaa = np.linalg.inv(aa)

for j, adsp in enumerate(data['displacements']):
   bname = basename+"-{0:0>3d}".format(j+1)
   f = open(bname+".cg",'w')
   s3 = s2.replace('{BASENAME}',bname)
   f.write(s3)
   cartd = ( np.mat(adsp['displacement']).T ) / oneau
   celld = invaa*cartd
   tatm = adsp['atom']
   for i, atm in enumerate(data['atoms']):
       num = asym2num[atm['symbol']]
       x = np.mat(atm['position']).T
       if i+1 == tatm:
           x = x + celld
       f.write("  {0:d} {1:19.11E} {2:19.11E} {3:19.11E}\n".format(num,x.item(0),x.item(1),x.item(2)))
   f.close()
