#! /usr/bin/python
# originally written by Kazuma Nakamura 2016/6/16
# modified by Yoshihide Yoshimoto 2016/6/16, 2016/6/27

import yaml
import sys
import fractions
import numpy

lim_denom = 1000

if (len(sys.argv) <= 1):
   fname = 'sym.yml'
else:
   fname = sys.argv[1]

fi = open(fname,'r')
data = yaml.load(fi)

denomlist = []
for sgop in data['space_group_operations']:
   pg = sgop['translation']
   for t in pg:
      denomlist.append(fractions.Fraction(t).limit_denominator(lim_denom).denominator)

comdenom = 1
for denom in denomlist:
   comdenom = (denom*comdenom)/fractions.gcd(denom,comdenom)

print("denom_trans = {0:3d}".format(int(round(comdenom))))

for sgop in data['space_group_operations']:
   rg = sgop['rotation']
   sg = numpy.transpose(numpy.linalg.inv(rg))
   pg = sgop['translation']
   print("{0:3d}{1:3d}{2:3d}{3:3d}{4:3d}{5:3d}{6:3d}{7:3d}{8:3d}{9:3d}{10:3d}{11:3d}".format(int(round(sg[0,0])),int(round(sg[1,0])),int(round(sg[2,0])),
          int(round(sg[0,1])),int(round(sg[1,1])),int(round(sg[2,1])),
          int(round(sg[0,2])),int(round(sg[1,2])),int(round(sg[2,2])),
          int(round(pg[0]*comdenom)),int(round(pg[1]*comdenom)),int(round(pg[2]*comdenom))))
